%global _vendor OpenCloudOS
%global rpmmdir /usr/lib/rpm/%{_vendor}
%global gopath  %{_datadir}/gocode
 
Summary:   Build-stage rpm automation for Go packages
Name:      go-rpm-macros
Version:   3.5.0
Release:    1%{?dist}
License:   GPLv3
URL:       https://pagure.io/go-rpm-macros
Source0:    %{name}-%{version}.tar.gz

BuildArch: noarch
Requires:  go-srpm-macros = %{version}-%{release}
Requires:  go-filesystem  = %{version}-%{release}
Requires:  golist
Requires:  golang

Provides:  compiler(golang)
Provides:  compiler(go-compiler) = 2

%description
This package provides build-stage rpm automation to simplify the creation of Go
language (golang) packages.
 
It does not need to be included in the default build root: go-srpm-macros will
pull it in for Go packages only.
 
%package -n go-srpm-macros
Summary:   Source-stage rpm automation for Go packages
Requires:  opencloudos-rpm-config
 
%description -n go-srpm-macros
This package provides SRPM-stage rpm automation to simplify the creation of Go
language (golang) packages.
 
It limits itself to the automation subset required to create Go SRPM packages
and needs to be included in the default build root.
 
The rest of the automation is provided by the go-rpm-macros package, that
go-srpm-macros will pull in for Go packages only.
 
%package -n go-filesystem
Summary:   Directories used by Go packages
 
%description -n go-filesystem
This package contains the basic directory layout used by Go packages.
 
%prep
%autosetup -p1
%writevars -f rpm/macros.d/macros.go-srpm gopath
 
%install
mkdir -p %{buildroot}%{rpmmdir}
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_fileattrsdir}
mkdir -p %{buildroot}%{_rpmconfigdir}/macros.d
mkdir -p %{buildroot}%{_rpmconfigdir}/%{_vendor}
mkdir -p %{buildroot}%{_rpmluadir}/%{_vendor}/{rpm,srpm}
mkdir -p %{buildroot}%{gopath}/src

install -m 0755 bin/* %{buildroot}%{_bindir}
install -m 0644 -vp   rpm/fileattrs/*.attr \
                      %{buildroot}%{_fileattrsdir}
install -m 0644 -vp   rpm/macros.d/macros.* \
                      %{buildroot}%{_rpmconfigdir}/macros.d
install -m 0644 -vp   rpm/lua/srpm-go.lua \
                      %{buildroot}%{_rpmluadir}/%{_vendor}/srpm/go.lua
install -m 0644 -vp   rpm/lua/rpm-go.lua \
                      %{buildroot}%{_rpmluadir}/%{_vendor}/rpm/go.lua
install -m 0755 -vp   rpm/*\.{prov,deps} \
                      %{buildroot}%{_rpmconfigdir}/
 
 
%files
%{_bindir}/go-rpm-integration
%{_rpmconfigdir}/macros.d/macros.go-rpm
%{_rpmconfigdir}/macros.d/macros.go-compilers-golang
%{_rpmconfigdir}/macros.d/macros.go-rpm.internal
%{_fileattrsdir}/go_mod_vendor.attr
%{_fileattrsdir}/go.attr
%{_fileattrsdir}/gobundled.attr
%{_fileattrsdir}/gosymlink.attr
%{_rpmluadir}/%{_vendor}/rpm/go.lua
%{_rpmconfigdir}/go_mod_vendor.prov
%{_rpmconfigdir}/gobundled.prov
%{_rpmconfigdir}/gosymlink.deps

%files -n go-filesystem
%dir %{gopath}
%dir %{gopath}/src
 
%files -n go-srpm-macros
%{_rpmconfigdir}/macros.d/macros.go-srpm
%{_rpmluadir}/%{_vendor}/srpm/go.lua
 
%changelog
* Fri Aug 02 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.5.0-1
- initial build
